(function () {

    var map,
        myCollection;

// когда яндекс карта соизволила реади
    ymaps.ready(function () {
        map = new ymaps.Map('map', {
            center:[56.326944, 44.0075],
            zoom:10,
            type:'yandex#map',
            behaviors:['default', 'scrollZoom']
        });

        //Добавляем элементы управления
        map.controls
            .add('zoomControl');
        //  .add('typeSelector')
        //  .add('mapTools');

        myCollection = new ymaps.GeoObjectCollection();

        var lay = $('#ya-map-tpl').html();

        var xxxLayout = ymaps.templateLayoutFactory.createClass(
            lay,
            {
                build:function () {
                    xxxLayout.superclass.build.call(this);
                    //console.log(this);
                    $('.b-map-ballon2__close').on('click', $.proxy(this.onCloseClick, this));
                },
                clear:function () {
                    $('.b-map-baloon__close').off('click');
                    this.constructor.superclass.build.call(this);
                },
                onCloseClick:function () {
                    this.getData().geoObject.balloon.close();
                }
            });

        //console.log(xxxLayout );

        do_search(glb.points);


        function do_search(json) {

            for (i = 0; i < json.length; i++) {

                var wd = '<table class="b-map-ballon2__wd">';

                $.each(json[i].wd, function (kay, value) {
                    $.each(value, function (days, time) {
                        //console.log(kay,value);
                        wd += '<tr>' +
                            '<td class="b-map-ballon2__wd-days">' + days + '</td>' +
                            '<td class="b-map-ballon2__wd-time">' + time + '</td>' +
                            '</tr>';
                    });
                });

                wd += '</table>';

                var placemark = new ymaps.Placemark([json[i].lon, json[i].lat], {
                    pointName:json[i].name,
                    pointAddress:json[i].address,
                    pointPhones:json[i].phones,
                    pointId:json[i].id,
                    pointWd:wd

                }, {
                    // Опции
                    balloonLayout:xxxLayout,
                    iconImageHref:'imgs/ya-maps/point-no.png', // картинка иконки
                    iconImageSize:[38, 52], // размеры картинки
                    balloonShadow:false,
                    balloonMaxWidth:800,
                    balloonMinWidth:445,
                    balloonOffset:[ -110 , 0],
                    balloonZIndex: 1111,
                    hideIconOnBalloonOpen:false,
                  //  balloonAutoPanMargin:140,
                    pointSelected:false
                    //balloonAutoPan: false
                    // iconImageOffset: [-3, -42] // смещение картинки
                });

                placemark.events

                    .add('mouseenter', function (e) {
                        // Ссылку на объект, вызвавший событие,
                        // можно получить из поля 'target'.
                        var target = e.get('target');
                        var id = target.properties.get('pointId');

                        $('.b-places__link[data-id="'+id+'"]').parents('tr').addClass('active');

                        target.options.set('iconImageHref', 'imgs/ya-maps/point.png');
                        // e.get('target').options.set('activ', 'x');
                    })
                    .add('mouseleave', function (e) {
                        var target = e.get('target');
                        var id = target.properties.get('pointId');
                        if (!target.options.get('pointSelected')) {
                            target.options.set('iconImageHref', 'imgs/ya-maps/point-no.png');
                            $('.b-places__link[data-id="'+id+'"]').parents('tr').removeClass('active');
                        }

                    });

                placemark.events.add('click', function (e) {


                    // e.get('target').options.set('iconImageHref', 'imgs/ya-maps/point.png');

                });


                // добавляем метки в коллекцию
                myCollection.add(placemark);
            }

            map.geoObjects.add(myCollection);
// Set center and zoom using collection bounds.
            map.setBounds(myCollection.getBounds(), {checkZoomRange:true});

        }


        $(function () {

            $('.b-places tr').on("hover", function (e) {
                var id = $(this).find('.b-places__link').data("id");

                selectPoint(id);
            });

            $('.b-places tr').on("click", function (e) {

                $('.b-places tr').removeClass('active');
                $(this).addClass('active');
                var id = $(this).find('.b-places__link').data("id");
                go_to(id);
                $('body').scrollTo('#map', 800);
            });

            $('.b-places__link').click(function (e) {
                e.preventDefault();
            });


            function selectPoint(id) {
                myCollection.each(function (item) {

                    id = parseInt(id, 10);
                    var idProp = parseInt(item.properties.get('pointId'), 10);

                    // console.log(idProp);
                    //  console.log(id);
                    //  console.log(id);


                    if (idProp === id) {
                        item.options.set('iconImageHref', 'imgs/ya-maps/point.png');
                    }
                    else {
                        if (!item.options.get('pointSelected')) {
                            item.options.set('iconImageHref', 'imgs/ya-maps/point-no.png');
                        }

                    }

                    //map.setBounds(myCollection.getBounds());
                });

                return false;
            }


            function go_to(id) {
                //lat,lon,address
              //  map.setCenter([56.796028, 60.581098], 16);

                myCollection.each(function (point) {

                    var idProp = parseInt(point.properties.get('pointId'), 10);
                    point.options.set('pointSelected', false);

                    if (id === idProp) {
                        //console.log(point);
                        // console.log(point.balloon);
                        // console.log(point.geometry);
                        // map.setCenter([56.796028, 60.581098], 16);

                        //центрируем карту на точку
                        point.options.set('balloonAutoPan', false);
                        point.options.set('iconImageHref', 'imgs/ya-maps/point.png');
                        point.options.set('pointSelected', true);
                        console.log(point.options.get('pointSelected'));
                        point.balloon.open();
                        map.setBounds(point.geometry.getBounds(),
                            {
                                checkZoomRange:true,
                                callback:function () {
                                    point.balloon.open();
                                    point.options.set('balloonAutoPan', true);
                                }
                            });
                        return false;
                    }
                });

                /*myCollection.each(function (item) {
                 if (item.properties.get('balloonContentHeader') == '<div style="color:#ff0303;font-weight:bold">'+address+'</div>') {
                 item.balloon.open();
                 placemark.balloon.open();
                 }
                 });*/
                return false;
            }
        });
    });

})();

